/*
 * Copyright (C) 2008-2021 Intel Corporation.
 * SPDX-License-Identifier: MIT
 */

// <COMPONENT>: util
// <FILE-TYPE>: component public header

#ifndef UTIL_HPP
#define UTIL_HPP

/*! @mainpage UTIL library
 *
 * The UTIL library provides a collection of generally useful utilities.
 */

/*! @brief The UTIL library. */
namespace UTIL
{
}

#include "util/data.hpp"
#include "util/intel-fp.hpp"
#include "util/locker.hpp"
#include "util/numberbits.hpp"
#include "util/quote-argument-ms.hpp"
#include "util/range.hpp"
#include "util/regvalue.hpp"
#include "util/round.hpp"
#include "util/scoped-ptr.hpp"
#include "util/scoped-array.hpp"
#include "util/strings.hpp"
#include "util/singleton.hpp"

#endif // file guard
